#ifndef __Mail4c_Exception_h__
#define __Mail4c_Exception_h__

#include <Mail4c/Mail4c.h>

#include <Base4c/Exception.h>

#include <string>
#include <vector>

namespace Mail4c
{
	const int DEX_INVALIDLINE = -1;

	static const int MEX_COMPOUNDEXCEPTION = Base4c::B4CX_DERIVEDBASE;
	static const int MEX_ALIENEXCEPTION = Base4c::B4CX_DERIVEDBASE + 1;
	static const int MEX_MAILERLOADFAIL = Base4c::B4CX_DERIVEDBASE + 11;
	static const int MEX_MAILERSYMLINKFAIL = Base4c::B4CX_DERIVEDBASE + 12;
	static const int MEX_DATATYPEMISMATCH = Base4c::B4CX_DERIVEDBASE + 21;

	class Mail4c_Export Exception : public Base4c::Exception
	{
		public:
			Exception( const std::string& strFile, int nLine, int nErrorCode, bool bFatal = false, const std::string& strLegend = std::string() );

			static std::string explainErrorCode( int nErrorCode );
	};

	class Mail4c_Export ExceptionList : public std::vector<Exception>
	{
	};

	class Mail4c_Export CompoundException : public Exception
	{
		private:
			ExceptionList _exceptionS;

		public:
			CompoundException();
			CompoundException( const std::string& strFile, int nLine );
			virtual ~CompoundException();

			const CompoundException& operator=( const CompoundException& e );

			bool hasExceptions() const;
			const ExceptionList& exceptions() const;
			void addException( const Exception& e );
			void addExceptions( const ExceptionList& e );
	};
}

#endif /* __Mail4c_Exception_h__ */
